angular.module('controls').directive('kkDashboard', ['core', 'utils', 'state', 'modal', 'packageManager', '$timeout', function(core, utils, state, modal, packageManager, $timeout) {

	return {

		restrict: 'E',
		scope: {},
		templateUrl: core.adminURL + 'js/controls/dashboard.html.js?' + new Date().getTime(),
		replace: true,

		link: function(scope, elem, attrs) {

			scope.core = core;
			scope.utils = utils;
			scope.state = state;
			scope.packageManager = packageManager;
			
			scope.view = { type : "installed", filter: "all" };
			scope.storePagination = {};
			scope.dropPagination = {};
			scope.search = "";
			scope.sidebarWidth = state.sidebar.width || 320;

			// remove hidden or unlicensed templates from selection
			scope.filterTemplates = function(templates) {
				var filtered = {};	
				for (var templateId in templates) {
					var template = templates[templateId];
					if (template && template.hidden) continue;
					//if (!utils.Drops.canAddDrop(templateId)) continue;
					filtered[templateId] = template;
				}
				return filtered;
			};

			scope.showPackageManager = function(mode, pkg) {
				modal.show('PackageManagerModal', null, {"overviewMode": null, "mode": mode || "overview", "package" : pkg || null});
			};

			scope.showSettings = function() {
				modal.show('SettingsModal', function() { });
			};
		
			scope.getUpgradesCount = function() {
				return Object.keys(core.packages.upgradeable).length;
			};

			scope.hasValidLicense = function(dropId) {
				if (!core.dropLicenses[dropId]) return false;
				return core.dropLicenses[dropId].isValid || false;
			};

			scope.getLicenceTypeName = function() {
		
				var types = {
					"kk_dropper_bronze" : "Bronze",
					"kk_dropper_silber" : "Silber",
					"kk_dropper_gold" : "Gold",
					"kk_dropper_super" : "Dev"
				};
		
				return types[core.dropperLicense.item];
		
			};
			
			var positionDashboardArrow = function() {
				var $area = $('#edit-windows');
				var $arrow = $('#drop-select .dashboard-arrow');
				var $btn = $('#topbar .dashboard-toggle');
				if (!$arrow.length || !$btn.length) {
					return setTimeout(positionDashboardArrow, 300);
				}
				var targetPos = $btn.offset().left + ($btn.outerWidth(false) / 2);
				var areaPos = $area.offset().left;
				$arrow.css('left', Math.floor(targetPos - areaPos) + 'px');
			};
			
			var measureSidebarWidth = function() {
				var $sidebar = $('.sidebar-wrapper');
				scope.sidebarWidth  = $sidebar.length ? $sidebar.outerWidth(false) : state.sidebar.width;
			};
			
			/**
			 * Shows the Drop Overview Page
			 */
			scope.$watch('state.dashboardOpen', function() {
		
				measureSidebarWidth();
		
				if (state.dashboardOpen) {
					$(elem).removeClass('select-offscreen');
					$('html').css('overflow', 'hidden');
					positionDashboardArrow();
				} else {
					$('html').css('overflow', '');
					$(elem).addClass('select-offscreen');
				}
		
			});
			
			$(window).resize(function() {
				$timeout(function() {
					positionDashboardArrow();
					measureSidebarWidth();
				});
			});

			// initially position dropdown arrow
			positionDashboardArrow();
			measureSidebarWidth();

		}
	};
}]);