angular.module('app').controller('LiveViewCtrl', [
	'$scope', 
	'core', 
	'message', 
	'modal', 
	'editWindow', 
	'media', 
	'utils', 

	function(
		$scope, 
		core, 
		message, 
		modal, 
		editWindow, 
		media, 
		utils
) {
		
	// check for iframe messages and react on them!
	window.addEventListener('message', function(e) {

		if (!e.data || !e.data.mode) return;
		
		switch(e.data.mode) {

			case 'edit-drop':

				var drop = utils.Drops.getDropByGuid(e.data.drop);

				console.log('activing drop', drop);

				$scope.$apply(function() {
					$scope.activateDrop(drop);
				});

			break;

		}

	}, false);
		

	/**
	 * Sets the active Drop (which is being edited)
	 * @param  {object} drop - the Drop
	 */
	$scope.activateDrop = function(drop, e) {

		if(e){
			e.preventDefault();
			e.stopPropagation();
		}

		if(typeof(drop) === 'string') {
			// this seems to be a guid, let's try to get a drop from it
			drop = utils.Drops.getDropByGuid(drop);
		}

		if(!drop) return;

		if(!core.templates[drop._internal.dropId]) {
			// no template found for this drop, show infos on click
			$scope.showDropInfo(drop._internal.dropId, 'licence');
			return;
		}

		editWindow.show(false, 'DropEditWindow', {
			'activeDrop' : drop,
			'activeTemplate' : core.templates[drop._internal.dropId]
		});
	};

}]);