angular.module('app').controller('DropInfoModalController', ['$modalScope', '$q', 'dropInfo', 'core', 'packageManager', 'modal', 'utils', function($modalScope, $q, dropInfo, core, packageManager, modal, utils) {

	$modalScope.delayShow = true;
	$modalScope.core = core;
	$modalScope.dropLicenses = core.dropLicenses;
	$modalScope.dropInfo = dropInfo;
	$modalScope.packageManager = packageManager;
	$modalScope.utils = utils;

	// get the url to retrieve a license
	$modalScope.getLicenseUrl = function(id, param) {
		if (core && core.packages && core.packages.installed && core.packages.installed[id] && core.packages.installed[id]['meta'] && core.packages.installed[id]['meta']['url']) {
			var url = core.packages.installed[id]['meta']['url'];
			if (url.indexOf('?') >= 0) { 
				url += '&';
			} else {
				url += '?';
			}
			url += 'shop=' + window.btoa(core.shopURL) + (param ? '&' + param : '');
			return url;
		}
		return null;
	};

	$modalScope.showUpdateManager = function(id) {
		$modalScope.close();
		modal.show('PackageManagerModal', null, {'mode': 'upgrade', 'overviewMode': 'upgrades', 'package' : core.packages.upgradeable[id]});
	};

	var showDoc = function(res) {
		$modalScope.dropInfo.description = res.documentation || '<h1>Sorry</h1><p>Für dieses Drop ist noch keine Beschreibung verfügbar.</p>';
		$modalScope.dropInfo.faq = res.faq || '';
		$modalScope.show();
	}

	var showDocError = function() {
		$modalScope.dropInfo.description = '<h1>Sorry</h1><p>Für dieses Drop ist noch keine Beschreibung verfügbar.</p>';
		$modalScope.dropInfo.faq = '';
		$modalScope.show();
	}

	// trigger drop docs event
	var promises = core.fn.trigger('getDropDocs', [dropInfo]);

	// run all promises
	$q.all(promises).then(function(results) {

		// find a valid result
		var res = results.find(function(result) {
			return result && angular.isString(result.documentation);
		});

		// did it yield a result yet?
		if (res) {
			showDoc(res);
		}
		// use default documentation provider
		else {
			$.ajax({
				type: 'POST',
				url: core.shopURL,
				data: {'kk_get_drop_documentation': dropInfo.dropId, 'kk_dropper_admin_pass': core.adminSecret},
				dataType: 'json',
				success: function(res) {
					$modalScope.$apply(function() {
						showDoc(res);
					});
				},
				error: function(err) {
					$modalScope.$apply(function() {
						showDocError();
					});
				}
			});
		}
	});

}]);