angular.module('app').controller('ListItemEditWindowController', ['$windowScope', 'environment', 'itemParent', 'item', 'itemSettings', 'useConditional', 'nameBinding', 'modal', 'core', function(scope, env, itemParent, item, itemSettings, useConditional, nameBinding, modal, core){
	scope.itemParent = itemParent;
	scope.item = item;
	scope.itemSettings = itemSettings;
	scope.useConditional = useConditional;
	scope.nameBinding = nameBinding;
	
	scope.showConditionalModal = function() {
		if (!scope.item || !scope.item._internal) return;

		modal.show(
			'ControlConditionalModal', 
			// close callback
			function (res) {
				if(angular.isObject(res)) {
					scope.item._internal.condition = res.condition;
					scope.item._internal.conditionalSettings = res.conditionalSettings;
				}
			},
			// injects
			{
				conditionalSettings: scope.item._internal.conditionalSettings || []
			}
		);
	};
	
	// watch for namebinding changes
	if (angular.isString(nameBinding)) {
		scope.$watch('item.' + nameBinding, function(name) {
			if (!scope.item || !angular.isObject(scope.item['_internal'])) return;
			
			if (name && angular.isObject(name) && name._multilanguage && name[env.languageDefault.cISO]) {
				scope.item['_internal']['name'] = '' + name[env.languageDefault.cISO];
				return;
			}
			else if (name && (angular.isString(name) || angular.isNumber(name))) { 
				scope.item['_internal']['name'] = '' + name;
				return;
			}
			
			scope.item['_internal']['name'] = 'Neuer Eintrag';
			
		}, true);
	}
}]);