conditional['ListingFilter'] = {
	description: 'Filtert nach gesetzten Shopfiltern (Listing)',
	name: 'Listingfilter',

	section: "Listing",
	sort: 40,

	config: [
		{
			type: "select",
			options: [
				{ label: "Kategorie", value: "category" },
				{ label: "Hersteller", value: "vendor" },
				{ label: "Merkmalwert", value: "property" },
				{ label: "Bewertung", value: "rating" },
				{ label: "Suchspezial", value: "special" }
			],
			property: "type"
		},
		{
			name: "Kategoriefilter",
			type: "select",
			options: "Categories",
			property: "category",
			condition: "drop.type == 'category'"
		},
		{
			name: "Herstellerfilter",
			type: "select",
			options: "Brands",
			property: "vendor",
			condition: "drop.type == 'vendor'"
		},
		{
			name: "Merkmalfilter",
			type: "multiselect",
			options: "ArticlePropertyValues",
			property: "properties",
			condition: "drop.type == 'property'"
		},
		{
			name: "Bewertungsfilter",
			type: "select",
			options: [
				{ label: "Ab 1 Sterne", value: "1" },
				{ label: "Ab 2 Sterne", value: "2" },
				{ label: "Ab 3 Sterne", value: "3" },
				{ label: "Ab 4 Sterne", value: "4" },
				{ label: "Ab 5 Sterne", value: "5" }
			],
			property: "rating",
			condition: "drop.type == 'rating'"
		},
		{
			name: "Suchespezialfilter",
			type: "select",
			options: [
				{label: "Bestseller", value: 1},
				{label: "Sonderangebote", value: 2},
				{label: "Neu im Sortiment", value: 3},
				{label: "Top Angebote", value: 4},
				{label: "In Kürze verfügbar", value: 5},
				{label: "Top bewertet", value: 6},
				{label: "Ausverkauft", value: 7},
				{label: "Auf Lager", value: 8},
				{label: "Vorbestellung Möglich", value: 9}
			],
			property: "special",
			condition: "drop.type == 'special'"
		}
	],
	evaluateToSmarty: function(filter){
		// no type given? invalid filter!
		if(!filter.type || filter.type.length == 0){
			return false;
		}

		var exp = '$nSeitenTyp eq 2 and (';
		
		switch(filter.type) {
			case 'category':
				if(!filter.category) return false;
				exp += 'isset($NaviFilter->KategorieFilter->kKategorie) and $NaviFilter->KategorieFilter->kKategorie eq ' + filter.category;
			break;
			case 'vendor':
				if(!filter.vendor) return false;
				exp += 'isset($NaviFilter->HerstellerFilter->kHersteller) and $NaviFilter->HerstellerFilter->kHersteller eq ' + filter.vendor;
			break;
			case 'property':
				if(!filter.properties || !filter.properties.length) return false;
				exp += '!empty($NaviFilter->MerkmalFilter) and (';
				for(var i=0; i<filter.properties.length; i++){
					var prop = filter.properties[i];
					exp += '$NaviFilter|is_propertyvalue_filtered:' + prop + (i < (filter.properties.length - 1) ? ' and ' : '');
				}
				exp += ')';
			break;
			case 'rating':
				if(!filter.rating) return false;
				exp += 'isset($NaviFilter->BewertungFilter->nSterne) and $NaviFilter->BewertungFilter->nSterne eq ' + filter.rating;
			break;
			case 'special':
				if(!filter.special) return false;
				exp += 'isset($NaviFilter->SuchspecialFilter->kKey) and $NaviFilter->SuchspecialFilter->kKey eq ' + filter.special;
			break;
			default:
				return false;
		}
		exp += ')';
		return exp;
	}
};