conditional['SessionDisplay'] = {
	description: 'Begrenzt die Anzeige auf eine konfigurierbare Anzahl (Session)',
	name: 'Anzeigelimit',
	legacy: true,	// don't show this yet, as it is not working as it should for now.
	section: "Session",
	sort: 30,
	
	config: [
		{
			description: 'Wie oft anzeigen?',
			type: 'text',
			append: 'mal',
			property: 'count'
		}
	],
	evaluateToSmarty: function(filter) {

		if(!filter.count) return false;
		
		// create some random GUID that is associated with this filter
		var guid = 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function(c) {
			var r = Math.random()*16|0, v = c == 'x' ? r : (r&0x3|0x8);
			return v.toString(16);
		});

		// id already given?		
		if (!filter.id) { 
			filter.id = guid;
		} else {
			guid = filter.id;
		}
		
		return '"' + guid + '"|session_display_count <= ' + (+filter.count);

	}
};