conditional['Turnus'] = {
	description: 'Erlaubt das Filtern nach dynamischen, wiederkehrenden Zeiträumen',
	name: 'Turnus',

	section: "Time",
	sort: 20,

	config: [
		{
			name: 'Tage',
			description: 'Tage des Monats (leer lassen für alle)',
			type: 'multiselect',
			property: 'days',
			options: (function(){ 
				var options = [];
				for(var i=1; i<=31; i++) {
					options.push({ label: '' + i, value: ('00' + i).slice(-2) });
				}
				return options;
			})()
		},
		{
			name: 'Monate',
			description: 'Monate des Jahres (leer lassen für alle)',
			type: 'multiselect',
			property: 'months',
			options: (function(){ 
				var options = [];
				var months = ['Januar', 'Februar', 'März', 'April', 'Mai', 'Juni', 'Juli', 'August', 'September', 'Oktober', 'November', 'Dezember'];
				for(var i=0; i<12; i++) {
					options.push({ label: months[i], value: ('00' + (i+1)).slice(-2) });
				}
				return options;
			})()
		},
		{
			name: 'Jahre',
			description: 'Jahre (leer lassen für alle)',
			type: 'multiselect',
			property: 'years',
			options: (function(){ 
				var options = [];
				var thisYear = new Date().getFullYear();
				for(var i=thisYear; i<thisYear+30; i++) {
					options.push({ label: '' + i, value: '' + i });
				}
				return options;
			})()
		},

	],
	evaluateToSmarty: function(filter){
		// nothing set?
		if(
			(!filter.days || !filter.days.length) && 
			(!filter.months || !filter.months.length) &&
			(!filter.years || !filter.years.length)
		){
			return false;
		}
		
		var dayExp = [];
		var monthExp = [];
		var yearExp = [];
		var allExp = [];
		var i;
		
		// days
		if (angular.isArray(filter.days) && filter.days.length) {
			for(i=0; i<filter.days.length; i++) {
				dayExp.push('$smarty.now|date_format:"%d" eq "' + filter.days[i] + '"');
			}
		}

		// months
		if (angular.isArray(filter.months) && filter.months.length) {
			for(i=0; i<filter.months.length; i++) {
				monthExp.push('$smarty.now|date_format:"%m" eq "' + filter.months[i] + '"');
			}
		}

		// years
		if (angular.isArray(filter.years) && filter.years.length) {
			for(i=0; i<filter.years.length; i++) {
				yearExp.push('$smarty.now|date_format:"%Y" eq "' + filter.years[i] + '"');
			}
		}
		
		
		if (dayExp.length) allExp.push('(' + dayExp.join(' or ') + ')');
		if (monthExp.length) allExp.push('(' + monthExp.join(' or ') + ')');
		if (yearExp.length) allExp.push('(' + yearExp.join(' or ') + ')');

		if (!allExp.length) return false;
		return allExp.join(' and ');
	}
};